#!/usr/local/bin/perl -w
# This is the fourth major rewrite of the Usenet-Web software
# Naturally, it is therefore version 1.0

# The Usenet-Web programs are copyrighted 1994 by Benjamin Franz
# (snowhare@netimages.com) and may be freely distributed and
# modified so long as no fees are charged.

# It would also be nice if you wrote me to tell me if you like it.

# This is the 'read resource file' sub-program. It takes no
# parameters and returns the global and newsgroup specific
# information from the resource file

$version="1.0.2";
$RESOURCEFILE="/home/users/snowhare/usenet-web/usenet-web.rc";

&ReadResourceFile;

sub UpdateResourceFile {
	local($line,$group,@newresource);

	open(RESOURCE,$RESOURCEFILE) 
		|| die("Unable to open $RESOURCEFILE\n$!");
	open(NEWRESOURCE,">${RESOURCEFILE}.newfile.31415") 
		|| die("Unable to open $RESOURCEFILE\n$!");;
	$group='';
	while($line=<RESOURCE>) {
		chop $line;
		if ($line=~m/^\s*NEWSGROUP\s*=\s*([A-Za-z][-._A-Za-z0-9]*)/) {
			$group=$1;
		}
		if (!$group) {
			print NEWRESOURCE "$line\n";
			next;
		}
		if ($line=~m/^\s*HIGH_MESSAGE\s*=\s*.+/) {
			print NEWRESOURCE 'HIGH_MESSAGE=',
				$resources{$group." HIGH_MESSAGE"},"\n";
			next;
		} elsif ($line=~m/^\s*MESSAGE_COUNT\s*=\s*.+/) {
			print NEWRESOURCE 'MESSAGE_COUNT=',
				$resources{$group." MESSAGE_COUNT"},"\n";
			next;
		} else {
			print NEWRESOURCE "$line\n";
		}
	}
	close(NEWRESOURCE);
	close(RESOURCE);

	open(RESOURCE,">$RESOURCEFILE") 
		|| die("Unable to open $RESOURCEFILE$!");
	open(NEWRESOURCE,"${RESOURCEFILE}.newfile.31415") 
		|| die("Unable to open $RESOURCEFILE$!");
	@newresource=<NEWRESOURCE>;
	print RESOURCE @newresource;

	close(NEWRESOURCE);
	close(RESOURCE);
	unlink "${RESOURCEFILE}.newfile.31415";
	chmod 0644,"$RESOURCEFILE";	
}


sub ReadResourceFile {
	local($line,$newsgroup,$field,$value);

	open(RESOURCE,$RESOURCEFILE) || die("Unable to open $RESOURCEFILE$!");
	while($line=<RESOURCE>) {
		chop $line;
		$line=~s/\s+$//;
		$line=~s#/+$##;
		if ($line=~m/^\s*NEWSGROUP\s*=\s*([A-Za-z][-._A-Za-z0-9]*)/) {
			$newsgroup=$1;
			$newsgrouplist{$newsgroup}=$newsgroup;
			next;
		}
		if (!$newsgroup) {
			if ($line=~m/^\s*SYSTEMIDENT\s*=\s*(.+)/) {
				$DefaultSystemIdentification=$1;
			} elsif ($line=~m/^\s*ICONPATH\s*=\s*(.+)/) {
				$DefaultIconPath=$1;
			} elsif ($line=~m/^\s*COMPRESS\s*=\s*(.+)/) {
				$COMPRESS=$1;
			} elsif ($line=~m/^\s*UNCOMPRESS\s*=\s*(.+)/) {
				$UNCOMPRESS=$1;
			} elsif ($line=~m/^\s*URLPATH\s*=\s*(.+)/) {
				$DefaultURLPath=$1;
			} elsif ($line=~m/^\s*ACTIVE_FILE\s*=\s*(.+)/) {
				$DefaultActiveFile=$1;
			} elsif ($line=~m/^\s*NEWS_SPOOL\s*=\s*(.+)/) {
				$DefaultNewsSpool=$1;
			} elsif ($line=~m/^\s*CACHE\s*=\s*(.+)/) {
				$CacheDirectory=$1;
			} elsif ($line=~m/^\s*CACHE_EXPIRY\s*=\s*(.+)/) {
				$CacheExpiry=$1;
			} elsif ($line=~m/^\s*ARCHIVE_DIRECTORY\s*=\s*(.+)/) {
				$DefaultArchiveDirectory=$1;
			} elsif ($line=~m/^\s*TRIPLE_HEADER_INDEX_FILE\s*=\s*(.+)/) {
				$DefaultTripleHeaderIndexFile=$1;
			} elsif ($line=~m/^\s*MESSAGE_ID_INDEX_FILE\s*=\s*(.+)/) {
				$DefaultMessageIDIndexFile=$1;
			}
			next;
		} else {
			$field='';
			($field,$value)=$line=~m#^\s*([A-Za-z][-._A-Za-z0-9]*)\s*=\s*(.+)#;
			if ($field) {
				$resources{$newsgroup." ".$field}=$value;
			}
		}
	}
	close(RESOURCE);
}

# Update the HighMessage and MessageCount in the in memory copy for a 
# particular newsgroup 

sub PutGroupInfo {
	local($group)=$newsgroup;
	$resources{$group." "."MESSAGE_COUNT"}=$MessageCount;
	$resources{$group." "."HIGH_MESSAGE"}=$HighMessage;
}


# Particularize  information for a newsgroup
sub GetGroupInfo {

        local($newsgroup)=$_[0];
        local($field,$value,$data,$key);

	$SystemIdentification=$DefaultSystemIdentification;
	$IconPath=$DefaultIconPath;
	$URLPath=$DefaultURLPath;
	$ARCHIVEDIRECTORY="${DefaultArchiveDirectory}/${newsgroup}";
	$ARCHIVEDIRECTORY=~s#\.#/#g;
	$TRIPLEHEADERINDEX=$DefaultTripleHeaderIndexFile;
	$MESSAGEIDINDEX=$DefaultMessageIDIndexFile;
	$ACTIVEFILE=$DefaultActiveFile;
	$NEWSSPOOL="${DefaultNewsSpool}/${newsgroup}";
	$NEWSSPOOL=~s#\.#/#g;
	$RemoveOriginal='';
	$FancyDisplay='yes';
	$UseActiveFile='yes';
	$Description='';

        foreach $key (sort keys(%resources)) {
                $data="$key $resources{$key}";
                if ($data=~m#^$newsgroup ([-.\w]+) (.+)#) {
                        $field=$1;
                        $value=$2;
			if ("$field"eq 'SYSTEMIDENT') {
				$SystemIdentification=$value;
				next;
			} elsif ("$field" eq 'ICONPATH') {
				$IconPath=$value;
				next;
			} elsif ("$field" eq 'URLPATH') {
				$URLPath=$value;
				next;
			} elsif ("$field" eq 'ARCHIVE_DIRECTORY') {
				$ARCHIVEDIRECTORY=$value;
				next;
			} elsif ("$field" eq 'ACTIVE_FILE') {
				$ACTIVEFILE=$value;
				next;
			} elsif ("$field" eq 'NEWS_SPOOL') {
				$NEWSSPOOL=$value;
				next;
			} elsif ("$field" eq 'REMOVE_ORIGINAL') {
				if ($value=~m/^yes$/i) {
					$RemoveOriginal=$value;
				}
				next;
			} elsif ("$field" eq 'USE_ACTIVE_FILE') {
				if ($value=~m/^no$/i) {
					$UseActiveFile='';
				}
				next;
			} elsif ("$field" eq 'FANCY_DISPLAY') {
				if ($value=~m/^no$/i) {
					$FancyDisplay='';
				}
				next;
			} elsif ("$field" eq 'MESSAGE_COUNT') {
				$MessageCount=$value;
				next;
			} elsif ("$field" eq 'HIGH_MESSAGE') {
				$HighMessage=$value;
				next;
			} elsif ("$field" eq 'MESSAGE_ID_INDEX_FILE') {
				$MESSAGEIDINDEX=$value;
				next;
			} elsif ("$field" eq 'TRIPLE_HEADER_INDEX_FILE') {
				$TRIPLEHEADERINDEX=$value;
				next;
			} elsif ("$field" eq 'DESCRIPTION') {
				$Description=$value;
				next;
			}
		}
	}
	$URLPath.="?" if (!($URLPath=~m#\?#));
	($URLAction,$URLParms)=split(/\?/,$URLPath);
}
